--- a/apps/app_alarmreceiver.c	2012-08-21 15:09:17.243271449 +0300
+++ b/apps/app_alarmreceiver.c	2012-08-21 15:12:29.514339642 +0300
@@ -578,17 +578,22 @@
 	char signalling_type[64] = "";
 	event_node_t *event_head = NULL;
 
-	/* Set write and read formats to ULAW */
-	ast_verb(4, "AlarmReceiver: Setting read and write formats to ULAW\n");
-
-	if (ast_set_write_format_by_id(chan,AST_FORMAT_ULAW)) {
-		ast_log(LOG_WARNING, "AlarmReceiver: Unable to set write format to Mu-law on %s\n",ast_channel_name(chan));
-		return -1;
+	if (ast_channel_writeformat(chan)->id != AST_FORMAT_ALAW
+		&& ast_channel_writeformat(chan)->id != AST_FORMAT_ULAW) {
+		ast_verb(4, "AlarmReceiver: Setting write format to Mu-law\n");
+		if (ast_set_write_format_by_id(chan,AST_FORMAT_ULAW)) {
+			ast_log(LOG_WARNING, "AlarmReceiver: Unable to set write format to Mu-law on %s\n",ast_channel_name(chan));
+			return -1;
+		}
 	}
 
-	if (ast_set_read_format_by_id(chan,AST_FORMAT_ULAW)) {
-		ast_log(LOG_WARNING, "AlarmReceiver: Unable to set read format to Mu-law on %s\n",ast_channel_name(chan));
-		return -1;
+	if (ast_channel_readformat(chan)->id != AST_FORMAT_ALAW
+		&& ast_channel_readformat(chan)->id != AST_FORMAT_ULAW) {
+		ast_verb(4, "AlarmReceiver: Setting read format to Mu-law\n");
+		if (ast_set_read_format_by_id(chan,AST_FORMAT_ULAW)) {
+			ast_log(LOG_WARNING, "AlarmReceiver: Unable to set read format to Mu-law on %s\n",ast_channel_name(chan));
+			return -1;
+		}
 	}
 
 	/* Set default values for this invocation of the application */
